Subject: bug#76248: [Feature Request] user-option for killing buffer in `quit-window'.

From: Juri Linkov <[email-masked]>
Date: Thu, 13 Feb 2025 09:53:56 +0200

>>> and honestly I would prefer an option like: "quit-window-kill-buffer"
>>> (set to `nil' by default).
>>
>> I completely agree.  The lack of this option causes so much trouble.
>
> Sounds useful, agreed.  Why not have the option.
>
>> For example, I needed to define in the init file:
>>
>>   (defun quit-window-kill-buffer ()
>>     "Quit WINDOW and kill its buffer."
>>     (interactive)
>>     (quit-window 1))
>>
>> and then update each and every keymap to override 'quit-window'
>> with 'quit-window-kill-buffer':
>>
>>   (define-key archive-mode-map "q" 'quit-window-kill-buffer)
>>   (define-key tar-mode-map "q" 'quit-window-kill-buffer)
>>   (define-key dired-mode-map "q" 'quit-window-kill-buffer)
>>   ...
>
> (Maybe an advice could work for this?)

An advice has too wide coverage.  Of course, it's possible
to check for major-mode in an advice.  But it would be more clean
to set a buffer-local value of the new option either to non-nil
in modes where 'q' should kill the buffer, or to nil in some modes
when the user customized the new option to non-nil for all modes.